x <- seq(-6,4,0.1)
y <- dlogis(x,location=-1)
plot(x,y,type="l",ylab="density",xlab="t")
ii <- (x <= 1)
polygon(c(x[ii],1,-6),c(y[ii],0,0),col='gray')
data(bliss,package="faraway")
bliss
mlogit <- glm(cbind(dead,alive) ~ conc, family=binomial, data=bliss)
mprobit <- glm(cbind(dead,alive) ~ conc, family=binomial(link=probit), data=bliss)
mcloglog <- glm(cbind(dead,alive) ~ conc, family=binomial(link=cloglog), data=bliss)
mcauchit <- glm(cbind(dead,alive) ~ conc, family=binomial(link=cauchit), data=bliss)
fitted(mlogit)
coef(mlogit)[1]+coef(mlogit)[2]*bliss$conc
library(faraway)
ilogit(mlogit$lin)
predval <- sapply(list(mlogit,mprobit,mcloglog,mcauchit),fitted)
dimnames(predval) <- list(0:4,c("logit","probit","cloglog","cauchit"))
round(predval,3)
dose <- seq(-4,8,0.2)
predval <- sapply(list(mlogit,mprobit,mcloglog,mcauchit),function(m) predict(m,data.frame(conc=dose),type="response"))
colnames(predval) <- c("logit","probit","cloglog","cauchit")
predval <- data.frame(dose,predval)
library(tidyr)
mpv <- gather(predval, link, probability, -dose)
library(ggplot2)
ggplot(mpv, aes(x=dose,y=probability,linetype=link))+geom_line()
ggplot(predval, aes(x=dose,y=probit/logit))+geom_line()+xlim(c(-4,0))
ggplot(predval, aes(x=dose,y=(1-probit)/(1-logit)))+geom_line()+xlim(c(4,8))
data(babyfood, package="faraway")
xtabs(disease/(disease + nondisease) ~ sex + food, babyfood)
babyfood[c(1,3),]
data(bliss, package="faraway")
lmod <- glm(cbind(dead,alive) ~ conc, family=binomial,data=bliss)
lmodsum <- summary(lmod)
x0 <- c(1,2.5)
eta0 <- sum(x0*coef(lmod))
ilogit(eta0)
(cm <- lmodsum$cov.unscaled)
se <- sqrt( t(x0) %*% cm %*% x0)
ilogit(c(eta0-1.96*se,eta0+1.96*se))
predict(lmod,newdata=data.frame(conc=2.5),se=T)
ilogit(c(0.58095-1.96*0.2263,0.58095+1.96*0.2263))
x0 <- c(1,-5)
se <- sqrt( t(x0) %*% cm %*% x0)
eta0 <- sum(x0*lmod$coef)
ilogit(c(eta0-1.96*se,eta0+1.96*se))
(ld50 <- -lmod$coef[1]/lmod$coef[2])
dr <- c(-1/lmod$coef[2],lmod$coef[1]/lmod$coef[2]^2)
sqrt(dr %*% lmodsum$cov.un %*% dr)[,]
c(2-1.96*0.178,2+1.96*0.178)
(ed90 <- (logit(0.9)-lmod$coef[1])/lmod$coef[2])
library(MASS)
dose.p(lmod,p=c(0.5,0.9))
data(amlxray, package="faraway")
head(amlxray)
amlxray[amlxray$downs=="yes",1:4]
(ii <- which(amlxray$downs=="yes"))
ramlxray <- amlxray[-c(ii,ii+1),]
library(survival)
cmod <- clogit(disease ~ Sex+Mray+Fray+CnRay+strata(ID),ramlxray)
summary(cmod)
cmodr <- clogit(disease ~ Fray+unclass(CnRay)+strata(ID),ramlxray)
summary(cmodr)
gmod <- glm(disease ~ Fray+unclass(CnRay),family=binomial,ramlxray)
summary(gmod)
